var _excluded = ["layout", "labelCol", "mainCol", "scrollerDOM", "children", "className"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState, useEffect, useImperativeHandle, forwardRef, useRef } from 'react';
import FormContext from "./../FormContext";

// layout: horizontal | vertical | inline
var VirtualForm = /*#__PURE__*/forwardRef(function (_ref, ref) {
  var _ref$layout = _ref.layout,
    layout = _ref$layout === void 0 ? 'horizontal' : _ref$layout,
    labelCol = _ref.labelCol,
    mainCol = _ref.mainCol,
    scrollerDOM = _ref.scrollerDOM,
    children = _ref.children,
    className = _ref.className,
    props = _objectWithoutProperties(_ref, _excluded);
  var rootRef = useRef(null);

  // Virtual
  var _useState = useState(null),
    _useState2 = _slicedToArray(_useState, 2),
    observer = _useState2[0],
    setObserver = _useState2[1];
  var observerCallbacksRef = useRef(new WeakMap());

  // Expose
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });
  useEffect(function () {
    // 创建IntersectionObserver实例
    // eslint-disable-next-line
    observer = new IntersectionObserver(function (entries) {
      entries.forEach(function (entry) {
        // console.log(entry.target.classList.contains('form-item'))
        var callback = observerCallbacksRef.current.get(entry.target);
        callback === null || callback === void 0 || callback(entry.isIntersecting);
      });
    }, {
      root: null,
      // 使用视口作为根
      threshold: 0.1 // 当10%的元素可见时触发
      // rootMargin: '0px',
    });
    setObserver(observer);

    // 组件卸载时清理
    return function () {
      if (observer) {
        observer.disconnect();
      }
    };
  }, []);
  return /*#__PURE__*/React.createElement(FormContext.Provider, {
    value: {
      layout: layout,
      labelCol: labelCol,
      mainCol: mainCol,
      scrollerDOM: scrollerDOM,
      virtual: {
        observer: observer,
        observerCallbacks: observerCallbacksRef.current
      }
    }
  }, /*#__PURE__*/React.createElement("div", _extends({
    ref: rootRef,
    className: "form-items virtual".concat(className ? ' ' + className : '')
  }, props), children));
});
export default VirtualForm;